   '***********************************************************************
   ' Kostka - elektronicka hraci kostka
   '
   ' elektronicka verze hraci kostky s kombinacemi cisel 1-6
   ' po zapnuti 7x losuje, zobrazi vyslednou kombinaci na LED a za 1,5s usne.
   ' Probudi se stiskem tlacitka, znovu vylosuje a zobrazi kombinaci na LED a usne...
   ' v 1.0 (27.5.2013)
   '
   ' Autor : Pavel Jank
   ' www.paja-trb.cz
   ' paja@paja-trb.cz
   '
   '***********************************************************************

$regfile = "attiny13.dat"                                   ' ATtiny13V
$crystal = 4800000                                          ' used crystal frequency
$hwstack = 16                                               '100
$swstack = 8                                                '64
$framesize = 24                                             '64

Config Portb = Output
Config Pinb.2 = Input : Set Portb.2
Led1 Alias Portb.0
Led2 Alias Portb.3
Led4 Alias Portb.4
Led6 Alias Portb.1
Portb = &B1111_1111

Config Timer0 = Timer , Prescale = 64                       'krok je 13us
Enable Timer0
On Timer0 Pretec

'PCINT2 - extrern preruseni - probuzen kostky
Set Pcmsk.pcint2
Set Gimsk.pcie
Config Int0 = Low Level                                     'ext.peruen0 nzkou rovn!
On Int0 Prerus Nosave                                       'probuzen z powerdown externm peruenm nzkou rovn

Enable Interrupts                                           'povol vsechna preruseni

Dim I As Byte , R As Byte
Dim Opak As Byte : Opak = 0
Dim Nahoda As Byte

'''''''''''''''''''''''''''' HLAVNI PROGRAM ''''''''''''''''''''''''''''''''''''
'vylosuj cislo, zobraz, pockej a usni
Do

   Do                                                       'opakovani losovani 7x (pro efekt)
     Portb = &B1111_1111                                       'vynuluje vystupy (zhasne LED)
     Waitms 35

     R = Rnd(5)                                                ''Rnd - Vrac Nhodn slo, R = 0az5
     Incr R                                                    'prevod na cisla 1az6

     I = R * 3
     I = Nahoda Mod I                                          'celociselny zbytek po deleni (11az255) / (1az6)
     If I = 0 Or I > 6 Then I = R                              'je-li I=0 nebo I>6, tak I = Random 1az6

     Select Case I                                             'podle vylosovaneho cisla rozsvit LEDky ve tvaru kostky
         Case 1 : Reset Led1
         Case 2 : Reset Led2
         Case 3 : Reset Led1
                  Reset Led2
         Case 4 : Reset Led2
                  Reset Led4
         Case 5 : Reset Led2
                  Reset Led4
                  Reset Led1
         Case 6 : Reset Led2
                  Reset Led4
                  Reset Led6
     End Select

     Waitms 80
     Incr Opak
   Loop Until Opak = 7                                         '7x zopakuj losovn sel

   Opak = 0                                                 'vynuluj opakovn
   Waitms 1500                                              'pokej (nech rozsvcen LED) 1,5s
   Portb = &B1111_1111                                      'vynuluje vystupy (zhasne LED)

   Powerdown                                                'usp procesor - odbr klesne na nkolik mikroampr.

Loop

''''''''''''''''''''''''' KONEC HLAVNIHO PROGRAMU ''''''''''''''''''''''''''''
End

'-----------------------------------------------------------------------------
Prerus:
    Gifr.pcif = 1                                           'vyma pznak peruen
Return

'-----------------------------------------------------------------------------
Pretec:
   If Nahoda < 10 Then Nahoda = 10
   Incr Nahoda                                              'Nahoda = 11 az 255
Return

'=============================================================================
' (c) PaJa-trb  2013 / www.paja-trb.cz / paja@paja-trb.cz